package components
{
	import flash.events.FocusEvent;
	import flash.events.MouseEvent;
	
	import mx.controls.Image;
	
	import spark.components.TextInput;
	
	public class ex_CTextInputCSS extends TextInput
	{
		// Etats
		[SkinState("focused")];
		
		// SkinParts
		[SkinPart(required="true")]
		public var btn:Image;
		
		// Propriétés
		private var _icon:String;		// Propriété Image.source du SkinPart "btn"
		private var _bfocused:Boolean;	// Etat "focused" du composant
		
		// Constructeur
		public function ex_CTextInputCSS()
		{
			super();
		}
		
		// Getters and Setters
		public function set icon(value:String):void
		{		
			if (_icon == value)
				return;
			_icon = value;
			
			if (btn)
				btn.source = _icon;
		}
		
		public function get icon():String
		{
			return _icon;
		}
		
		// Ajout des actions des SkinParts
		override protected function partAdded(partName:String, instance:Object):void
		{
			super.partAdded(partName, instance);
			// SkinPart Image "btn"
			if (instance == btn)
			{
				btn.addEventListener(MouseEvent.CLICK, btnClick_handler);
				btn.source = _icon;
			}
			// SkinPart RichEditableText "textDisplay"
			if (instance == this.textDisplay)
			{
				this.textDisplay.addEventListener(FocusEvent.FOCUS_IN,
					onFocusInHandler);
				this.textDisplay.addEventListener(FocusEvent.FOCUS_OUT,
					onFocusOutHandler);
			}
		}
		
		// Suppression des actions des SkinParts
		override protected function partRemoved(partName:String, instance:Object):void
		{
			super.partRemoved(partName, instance);
			// Button event listener
			if (instance == btn)
			{
				btn.removeEventListener(MouseEvent.CLICK, btnClick_handler);
			}
			// Focus event listener
			if (instance == this.textDisplay)
			{
				this.textDisplay.removeEventListener(FocusEvent.FOCUS_IN,
					onFocusInHandler);
				this.textDisplay.removeEventListener(FocusEvent.FOCUS_OUT,
					onFocusOutHandler);
			}
		}
		
		// Etat du composant
		override protected function getCurrentSkinState():String {
			if (_bfocused) {
				return "focused";
			} else {
				return super.getCurrentSkinState();
			}
		}
		
		// Focus IN handler
		private function onFocusInHandler(event:FocusEvent):void {
			_bfocused = true;
			invalidateSkinState();
		}
		
		// Focus OUT handler
		private function onFocusOutHandler(event:FocusEvent):void {
			_bfocused = false;
			invalidateSkinState();
		}
		
		// Handler sur le bouton
		private function btnClick_handler(event : MouseEvent):void
		{
			this.textDisplay.text = "";
		}
	}
}